package net.moonleay.gimble.editor

import net.moonleay.gimble.build.BuildConstants
import net.moonleay.gimble.editor.state.EditorState
import net.moonleay.gimble.editor.state.mode.ModeModifier
import org.apache.logging.log4j.LogManager
import java.util.UUID

object ServerEditorManager {
    private val LOGGER = LogManager.getLogger(BuildConstants.modName)

    val STATEMAP = mutableMapOf<UUID, EditorState>()

    fun updateEditorState(playerUUID: UUID, editorState: EditorState) {
        STATEMAP[playerUUID] = editorState
        LOGGER.info("$playerUUID: ${editorState.editorMode} with ${editorState.editorModifier}")
    }

    fun getEditorState(playerUUID: UUID): EditorState? {
        return STATEMAP[playerUUID]
    }

    fun playerHasModifier(playerUUID: UUID, modifier: ModeModifier): Boolean {
        if (!STATEMAP.containsKey(playerUUID))
            return false
        return STATEMAP[playerUUID]!!.editorModifier.contains(modifier) ?: false
    }
}
