package net.moonleay.gimble.networking

import kotlinx.serialization.ExperimentalSerializationApi
import kotlinx.serialization.cbor.Cbor
import kotlinx.serialization.encodeToByteArray
import net.fabricmc.fabric.api.client.networking.v1.ClientPlayNetworking
import net.fabricmc.fabric.api.networking.v1.PacketByteBufs
import net.moonleay.gimble.editor.state.EditorState

object GimbleClient {

    /**
     * Sends the given [EditorState] to the server.
     */
    @OptIn(ExperimentalSerializationApi::class)
    fun sendEditorState(state: EditorState) {
        val buf = PacketByteBufs.create()
        buf.writeByteArray(Cbor.encodeToByteArray(state))
        ClientPlayNetworking.send(PacketIDs.UPDATE_EDITOR_STATE_ID, buf)
    }
}
